This patch removes Rule-Based Classification Engine from CKRM as a prelude to
implementing the same functionality in userspace.

Most of this patch is removing whole CKRM files:
 fs/exec.c                         |    2
 fs/rcfs/rootdir.c                 |   30
 fs/rcfs/super.c                   |   50 -
 include/linux/ckrm.h              |   47 +
 include/linux/ckrm_ce.h           |   95 --
 include/linux/ckrm_events.h       |  202 -----
 include/linux/ckrm_rc.h           |   45 -
 include/linux/ckrm_tc.h           |   20
 include/linux/crbce.h             |  165 ----
 include/linux/rbce.h              |   78 --
 include/linux/rcfs.h              |    3
 include/linux/sched.h             |   23
 init/Kconfig                      |   40 -
 init/main.c                       |    2
 kernel/ckrm/Makefile              |    3
 kernel/ckrm/ckrm.c                |   99 --
 kernel/ckrm/ckrm_events.c         |   86 --
 kernel/ckrm/ckrm_sockc.c          |   49 -
 kernel/ckrm/ckrm_tc.c             |  307 --------
 kernel/ckrm/ckrmutils.c           |   39 -
 kernel/ckrm/rbce/Makefile         |   12
 kernel/ckrm/rbce/crbce_ext.c      |  580 ----------------
 kernel/ckrm/rbce/crbce_main.c     |    2
 kernel/ckrm/rbce/rbce_bitvector.h |  146 ----
 kernel/ckrm/rbce/rbce_core.c      |  928 --------------------------
 kernel/ckrm/rbce/rbce_fs.c        |  365 ----------
 kernel/ckrm/rbce/rbce_internal.h  |  265 -------
 kernel/ckrm/rbce/rbce_main.c      | 1279 ------------------------------------
 kernel/ckrm/rbce/rbce_token.c     |  241 ------
 kernel/exit.c                     |    3
 kernel/fork.c                     |   11
 kernel/sys.c                      |   13
 net/ipv4/tcp.c                    |    5
 33 files changed, 125 insertions(+), 5110 deletions(-)

Signed-off-by: Matt Helsley <matthltc@us.ibm.com>

Index: linux-2.6.13-rc6/include/linux/ckrm_rc.h
===================================================================
--- linux-2.6.13-rc6.orig/include/linux/ckrm_rc.h
+++ linux-2.6.13-rc6/include/linux/ckrm_rc.h
@@ -22,12 +22,10 @@
 #define _LINUX_CKRM_RC_H
 
 #ifdef CONFIG_CKRM
 
 #include <linux/list.h>
-#include <linux/ckrm_events.h>
-#include <linux/ckrm_ce.h>
 #include <linux/seq_file.h>
 
 #define CKRM_MAX_CLASSTYPES         32	/* maximum number of class types */
 #define CKRM_MAX_CLASSTYPE_NAME     32 	/* maximum classtype name length */
 
@@ -117,16 +115,10 @@ struct ckrm_classtype {
 
 	struct ckrm_core_class *default_class;
 	struct list_head classes;  /* link all classes of this classtype */
 	int num_classes;
 
-	/* state about my ce interaction */
-	atomic_t ce_regd;		/* if CE registered */
-	int ce_cb_active;		/* if Callbacks active */
-	atomic_t ce_nr_users;		/* number of active transient calls */
-	struct ckrm_eng_callback ce_callbacks;	/* callback engine */
-
 	/* Begin classtype-rcfs private data. No rcfs/fs specific types used.  */
 
 	int mfidx;		/* Index into genmfdesc array used to initialize */
 	void *mfdesc;		/* Array of descriptors of root and magic files */
 	int mfcount;		/* length of above array */
@@ -185,11 +177,11 @@ struct ckrm_core_class {
 	void *res_class[CKRM_MAX_RES_CTLRS];	/* resource classes */
 	spinlock_t class_lock;	                /* protects list,array above */
 
 	struct list_head objlist;		/* generic object list */
 	struct list_head clslist;		/* peer classtype classes */
-	struct dentry *dentry;			/* dentry of inode in the RCFS */
+	struct dentry *dentry;			/* dentry of inode in RCFS */
 	int magic;
 
 	struct ckrm_hnode hnode;		/* hierarchy */
 	rwlock_t hnode_rwlock;			/* protects hnode above. */
 	atomic_t refcnt;
@@ -293,48 +285,13 @@ static inline unsigned int ckrm_is_core_
            )
 
 extern struct ckrm_classtype *ckrm_classtypes[];
 
 /*
- * CE Invocation interface
- */
-
-#define ce_protect(ctype)      (atomic_inc(&((ctype)->ce_nr_users)))
-#define ce_release(ctype)      (atomic_dec(&((ctype)->ce_nr_users)))
-
-/* CE Classification callbacks with */
-
-#define CE_CLASSIFY_NORET(ctype, event, objs_to_classify...)		\
-do {									\
-	if ((ctype)->ce_cb_active					\
-	    && (test_bit(event,&(ctype)->ce_callbacks.c_interest)))	\
-		(*(ctype)->ce_callbacks.classify)(event,		\
-						  objs_to_classify);	\
-} while (0)
-
-#define CE_CLASSIFY_RET(ret, ctype, event, objs_to_classify...)		\
-do {									\
-	if ((ctype)->ce_cb_active					\
-	    && (test_bit(event,&(ctype)->ce_callbacks.c_interest)))	\
-		ret = (*(ctype)->ce_callbacks.classify)(event,		\
-							objs_to_classify);\
-} while (0)
-
-#define CE_NOTIFY(ctype, event, cls, objs_to_classify)			\
-do {									\
-	if ((ctype)->ce_cb_active					\
-	    && (test_bit(event,&(ctype)->ce_callbacks.n_interest)))	\
-		(*(ctype)->ce_callbacks.notify)(event,			\
-						cls,objs_to_classify);	\
-} while (0)
-
-/*
  * RCFS related
  */
 
 /* vars needed by other modules/core */
-
 extern int rcfs_mounted;
-extern int rcfs_engine_regd;
 
 #endif /* CONFIG_CKRM */
 #endif /* _LINUX_CKRM_RC_H */
Index: linux-2.6.13-rc6/fs/rcfs/super.c
===================================================================
--- linux-2.6.13-rc6.orig/fs/rcfs/super.c
+++ linux-2.6.13-rc6/fs/rcfs/super.c
@@ -27,11 +27,10 @@
 #include <linux/smp_lock.h>
 #include <linux/backing-dev.h>
 #include <linux/parser.h>
 #include <linux/rcfs.h>
 #include <linux/ckrm_rc.h>
-#include <linux/ckrm_ce.h>
 #include <asm/uaccess.h>
 
 static kmem_cache_t *rcfs_inode_cachep;
 
 inline struct rcfs_inode_info *rcfs_get_inode_info(struct inode *inode)
@@ -154,30 +153,10 @@ static int rcfs_fill_super(struct super_
 		printk("A non null classtype\n");
 
 		if ((rc = rcfs_register_classtype(clstype)))
 			continue;	/* could return with an error too */
 	}
-
-	/*
-	 * do post-mount initializations needed by CE
-	 * this is distinct from CE registration done on rcfs module load
-	 */
-	if (rcfs_engine_regd) {
-		if (rcfs_eng_callbacks.mnt)
-			if ((rc = (*rcfs_eng_callbacks.mnt) ())) {
-				printk(KERN_ERR "Error in CE mnt %d\n", rc);
-			}
-	}
-	/*
-	 * Following comment handled by code above; keep nonetheless if it
-	 * can be done better
-	 *
-	 * register CE's with rcfs
-	 * check if CE loaded
-	 * call rcfs_register_engine for each classtype
-	 * AND rcfs_mkroot (preferably subsume latter in former)
-	 */
 	return 0;
 }
 
 static struct super_block *rcfs_get_sb(struct file_system_type *fs_type,
 				       int flags, const char *dev_name,
@@ -206,39 +185,10 @@ void rcfs_kill_sb(struct super_block *sb
 			printk(KERN_ERR "Error removing classtype %s\n",
 			       clstype->name);
 		}
 	}
 
-	/*
-	 * do pre-umount shutdown needed by CE
-	 * this is distinct from CE deregistration done on rcfs module unload
-	 */
-	if (rcfs_engine_regd) {
-		if (rcfs_eng_callbacks.umnt)
-			if ((rc = (*rcfs_eng_callbacks.umnt) ())) {
-				printk(KERN_ERR "Error in CE umnt %d\n", rc);
-				/* TODO: return ; until error handling improves */
-			}
-	}
-	/*
-	 * Following comment handled by code above; keep nonetheless if it
-	 * can be done better
-	 *
-	 * deregister CE with rcfs
-	 * Check if loaded
-	 * if ce is in  one directory /rcfs/ce,
-	 *       rcfs_deregister_engine for all classtypes within above
-	 *             codebase
-	 *       followed by
-	 *       rcfs_rmroot here
-	 * if ce in multiple (per-classtype) directories
-	 *       call rbce_deregister_engine within ckrm_deregister_classtype
-	 *
-	 * following will automatically clear rcfs root entry including its
-	 *  rcfs_inode_info
-	 */
-
 	generic_shutdown_super(sb);
 }
 
 static struct file_system_type rcfs_fs_type = {
 	.name = "rcfs",
Index: linux-2.6.13-rc6/include/linux/rcfs.h
===================================================================
--- linux-2.6.13-rc6.orig/include/linux/rcfs.h
+++ linux-2.6.13-rc6/include/linux/rcfs.h
@@ -1,13 +1,11 @@
 #ifndef _LINUX_RCFS_H
 #define _LINUX_RCFS_H
 
 #include <linux/kernel.h>
 #include <linux/fs.h>
-#include <linux/ckrm_events.h>
 #include <linux/ckrm_rc.h>
-#include <linux/ckrm_ce.h>
 
 /*
  * The following declarations cannot be included in any of ckrm*.h files
  * without jumping hoops. Remove later when rearrangements done
  */
@@ -94,8 +92,7 @@ int rcfs_deregister_classtype(struct ckr
 int rcfs_mkroot(struct rcfs_magf *, int, struct dentry **);
 int rcfs_rmroot(struct dentry *);
 
 #define RCFS_ROOT "/rcfs"  	/* TODO:  Should use the mount point */
 extern struct dentry *rcfs_rootde;
-extern struct rbce_eng_callback rcfs_eng_callbacks;
 
 #endif	/* _LINUX_RCFS_H */
Index: linux-2.6.13-rc6/fs/rcfs/rootdir.c
===================================================================
--- linux-2.6.13-rc6.orig/fs/rcfs/rootdir.c
+++ linux-2.6.13-rc6/fs/rcfs/rootdir.c
@@ -28,40 +28,10 @@
 #include <linux/backing-dev.h>
 #include <linux/parser.h>
 #include <linux/rcfs.h>
 #include <asm/uaccess.h>
 
-struct rbce_eng_callback rcfs_eng_callbacks = {
-	NULL, NULL
-};
-
-int rcfs_register_engine(struct rbce_eng_callback * rcbs)
-{
-	if (!rcbs->mkdir || rcfs_eng_callbacks.mkdir) {
-		return -EINVAL;
-	}
-	rcfs_eng_callbacks = *rcbs;
-	rcfs_engine_regd++;
-	return 0;
-}
-
-EXPORT_SYMBOL_GPL(rcfs_register_engine);
-
-int rcfs_unregister_engine(struct rbce_eng_callback * rcbs)
-{
-	if (!rcbs->mkdir || !rcfs_eng_callbacks.mkdir ||
-	    (rcbs->mkdir != rcfs_eng_callbacks.mkdir)) {
-		return -EINVAL;
-	}
-	rcfs_eng_callbacks.mkdir = NULL;
-	rcfs_eng_callbacks.rmdir = NULL;
-	rcfs_engine_regd--;
-	return 0;
-}
-
-EXPORT_SYMBOL_GPL(rcfs_unregister_engine);
-
 /*
  * rcfs_mkroot
  * Create and return a "root" dentry under /rcfs.
  * Also create associated magic files
  *
Index: linux-2.6.13-rc6/kernel/ckrm/Makefile
===================================================================
--- linux-2.6.13-rc6.orig/kernel/ckrm/Makefile
+++ linux-2.6.13-rc6/kernel/ckrm/Makefile
@@ -1,9 +1,8 @@
 #
 # Makefile for CKRM
 #
 
-obj-y += ckrm_events.o ckrm.o ckrmutils.o
+obj-y += ckrm.o ckrmutils.o
 obj-$(CONFIG_CKRM_TYPE_TASKCLASS) += ckrm_tc.o ckrm_numtasks_stub.o
 obj-$(CONFIG_CKRM_TYPE_SOCKETCLASS) += ckrm_sockc.o
 obj-$(CONFIG_CKRM_RES_NUMTASKS) += ckrm_numtasks.o
-obj-$(CONFIG_CKRM_RBCE) += rbce/
Index: linux-2.6.13-rc6/kernel/ckrm/ckrm.c
===================================================================
--- linux-2.6.13-rc6.orig/kernel/ckrm/ckrm.c
+++ linux-2.6.13-rc6/kernel/ckrm/ckrm.c
@@ -27,10 +27,11 @@
 #include <linux/mm.h>
 #include <linux/string.h>
 #include <linux/list.h>
 #include <linux/spinlock.h>
 #include <linux/module.h>
+#include <linux/ckrm.h>
 #include <linux/ckrm_rc.h>
 #include <linux/rcfs.h>
 #include <net/sock.h>
 #include <linux/ip.h>
 
@@ -40,13 +41,10 @@
 rwlock_t ckrm_class_lock;	/* protects classlists */
 
 struct rcfs_functions rcfs_fn;
 EXPORT_SYMBOL_GPL(rcfs_fn);
 
-int rcfs_engine_regd;		/* rcfs state needed by another module */
-EXPORT_SYMBOL_GPL(rcfs_engine_regd);
-
 int rcfs_mounted;
 EXPORT_SYMBOL_GPL(rcfs_mounted);
 
 /*
  * Helper Functions
@@ -119,17 +117,10 @@ EXPORT_SYMBOL_GPL(ckrm_classobj);
 
 /*
  * Internal Functions/macros
  */
 
-static inline void set_callbacks_active(struct ckrm_classtype *ctype)
-{
-	ctype->ce_cb_active = ((atomic_read(&ctype->ce_regd) > 0) &&
-			       (ctype->ce_callbacks.always_callback
-				|| (ctype->num_classes > 1)));
-}
-
 int ckrm_validate_and_grab_core(struct ckrm_core_class *core)
 {
 	int rc = 0;
 	read_lock(&ckrm_class_lock);
 	if (likely(ckrm_is_core_valid(core))) {
@@ -139,87 +130,10 @@ int ckrm_validate_and_grab_core(struct c
 	read_unlock(&ckrm_class_lock);
 	return rc;
 }
 
 /*
- * Interfaces for classification engine
- */
-
-/*
- * Registering a callback structure by the classification engine.
- *
- * Returns typeId of class on success -errno for failure.
- */
-int ckrm_register_engine(const char *typename, struct ckrm_eng_callback * ecbs)
-{
-	struct ckrm_classtype *ctype;
-
-	ctype = ckrm_find_classtype_by_name(typename);
-	if (ctype == NULL)
-		return (-ENOENT);
-
-	atomic_inc(&ctype->ce_regd);
-
-	/* another engine registered or trying to register ? */
-	if (atomic_read(&ctype->ce_regd) != 1) {
-		atomic_dec(&ctype->ce_regd);
-		return (-EBUSY);
-	}
-
-	/*
-	 * One of the following must be set:
-	 * classify, class_delete (due to object reference) or
-	 * notify (case where notification supported but not classification)
-	 * The function pointer must be set the momement the mask is non-null
-	 */
-	if (!(((ecbs->classify) && (ecbs->class_delete)) || (ecbs->notify)) ||
-	    (ecbs->c_interest && ecbs->classify == NULL) ||
-	    (ecbs->n_interest && ecbs->notify == NULL)) {
-		atomic_dec(&ctype->ce_regd);
-		return -EINVAL;
-	}
-
-	ctype->ce_callbacks = *ecbs;
-	set_callbacks_active(ctype);
-
-	if (ctype->ce_callbacks.class_add) {
-		struct ckrm_core_class *core;
-
-		read_lock(&ckrm_class_lock);
-		list_for_each_entry(core, &ctype->classes, clslist) {
-			(*ctype->ce_callbacks.class_add) (core->name, core,
-							  ctype->type_id);
-		}
-		read_unlock(&ckrm_class_lock);
-	}
-	return ctype->type_id;
-}
-
-/*
- * Unregistering a callback structure by the classification engine.
- *
- * Returns 0 on success -errno for failure.
- */
-int ckrm_unregister_engine(const char *typename)
-{
-	struct ckrm_classtype *ctype;
-
-	ctype = ckrm_find_classtype_by_name(typename);
-	if (ctype == NULL)
-		return (-ENOENT);
-
-	ctype->ce_cb_active = 0;
-	if (atomic_read(&ctype->ce_nr_users) > 1) {
-		/* Somebody is currently using the engine, cannot deregister. */
-		return (-EAGAIN);
-	}
-	atomic_set(&ctype->ce_regd, 0);
-	memset(&ctype->ce_callbacks, 0, sizeof(struct ckrm_eng_callback));
-	return 0;
-}
-
-/*
  * Interfaces to manipulate class (core or resource) hierarchies
  */
 
 static void
 ckrm_add_child(struct ckrm_core_class *parent, struct ckrm_core_class *child)
@@ -423,11 +337,10 @@ ckrm_init_core_class(struct ckrm_classty
 
 	INIT_LIST_HEAD(&dcore->objlist);
 	list_add_tail(&dcore->clslist, &clstype->classes);
 
 	clstype->num_classes++;
-	set_callbacks_active(clstype);
 
 	write_unlock(&ckrm_class_lock);
 	ckrm_add_child(parent, dcore);
 
 	for (i = 0; i < clstype->max_resid; i++)
@@ -497,11 +410,10 @@ void ckrm_free_core_class(struct ckrm_co
 	core->res_class = NULL;
 #endif
 	/* Remove this core class from its linked list. */
 	list_del(&core->clslist);
 	clstype->num_classes--;
-	set_callbacks_active(clstype);
 	write_unlock(&ckrm_class_lock);
 
 	/* fix for race condition seen in stress with numtasks */
 	if (parent)
 		ckrm_core_drop(parent);
@@ -842,11 +754,10 @@ void __init ckrm_init(void)
 	/* register/initialize the Metatypes */
 
 #ifdef CONFIG_CKRM_TYPE_TASKCLASS
 	{
 		extern void ckrm_meta_init_taskclass(void);
-		ckrm_cb_newtask(&init_task);
 		ckrm_meta_init_taskclass();
 		/* prepare init_task and then rely on inheritance
 		   of properties */
 	}
 #endif
@@ -857,13 +768,10 @@ void __init ckrm_init(void)
 	}
 #endif
 	printk("CKRM Initialization done\n");
 }
 
-EXPORT_SYMBOL_GPL(ckrm_register_engine);
-EXPORT_SYMBOL_GPL(ckrm_unregister_engine);
-
 EXPORT_SYMBOL_GPL(ckrm_register_res_ctlr);
 EXPORT_SYMBOL_GPL(ckrm_unregister_res_ctlr);
 
 EXPORT_SYMBOL_GPL(ckrm_init_core_class);
 EXPORT_SYMBOL_GPL(ckrm_free_core_class);
@@ -876,15 +784,10 @@ EXPORT_SYMBOL_GPL(ckrm_find_classtype_by
 EXPORT_SYMBOL_GPL(ckrm_core_grab);
 EXPORT_SYMBOL_GPL(ckrm_core_drop);
 EXPORT_SYMBOL_GPL(ckrm_is_core_valid);
 EXPORT_SYMBOL_GPL(ckrm_validate_and_grab_core);
 
-EXPORT_SYMBOL_GPL(ckrm_register_event_set);
-EXPORT_SYMBOL_GPL(ckrm_unregister_event_set);
-EXPORT_SYMBOL_GPL(ckrm_register_event_cb);
-EXPORT_SYMBOL_GPL(ckrm_unregister_event_cb);
-
 EXPORT_SYMBOL_GPL(ckrm_class_show_stats);
 EXPORT_SYMBOL_GPL(ckrm_class_show_config);
 EXPORT_SYMBOL_GPL(ckrm_class_show_shares);
 
 EXPORT_SYMBOL_GPL(ckrm_class_set_config);
Index: linux-2.6.13-rc6/init/Kconfig
===================================================================
--- linux-2.6.13-rc6.orig/init/Kconfig
+++ linux-2.6.13-rc6/init/Kconfig
@@ -200,50 +200,10 @@ config CKRM_RES_NUMTASKS
 	help
 	  Provides a Resource Controller for CKRM that allows limiting no of
 	  tasks a task class can have.
 
 	  Say N if unsure, Y to use the feature.
-
-
-choice
-	prompt "Classification Engine"
-	depends on CKRM && RCFS_FS
-	default CKRM_RBCE
-	optional
-	help
-	 Select a classification engine (CE) that assists in
-	 automatic classification of kernel objects managed by CKRM when
-	 they are created. Without a CE, a user must manually
-	 classify objects into classes. Processes inherit their parent's
-	 classification.
-
-	 Only one engine can be built into the kernel though all can be
-	 built as modules (only one will load).
-
- 	 Classification engines are optional component of CKRM.
-	 If unsure, say N.
-
-config CKRM_RBCE
-	tristate "Rule-based Classification Engine (RBCE)"
-	help
-	  Vanilla Rule-based Classification Engine (RBCE). Rules for
-	  classifying kernel objects are created/deleted/modified through
-	  a RCFS directory using a filesystem interface.
-
-config CKRM_CRBCE
-	tristate "Enhanced Rule-based Classification Engine (CRBCE)"
-	depends on DELAY_ACCT && NET
-	help
- 	  Enhanced Rule-based Classification Engine (CRBCE). Like the Vanilla
- 	  RBCE, rules for classifying kernel objects are created, deleted and
- 	  modified through a RCFS directory using a filesystem interface
- 	  (requires CKRM_RCFS configured).
-
- 	  In addition, CRBCE provides per-process delay data
- 	  (requires DELAY_ACCT configured) and makes information on significant
- 	  kernel events available to userspace tools through netlink.
-endchoice
 endmenu
 
 config SYSCTL
 	bool "Sysctl support"
 	---help---
Index: linux-2.6.13-rc6/kernel/ckrm/ckrmutils.c
===================================================================
--- linux-2.6.13-rc6.orig/kernel/ckrm/ckrmutils.c
+++ linux-2.6.13-rc6/kernel/ckrm/ckrmutils.c
@@ -18,48 +18,12 @@
 #include <linux/err.h>
 #include <linux/mount.h>
 #include <linux/module.h>
 #include <linux/ckrm_rc.h>
 
-int get_exe_path_name(struct task_struct *tsk, char *buf, int buflen)
-{
-	struct vm_area_struct *vma;
-	struct vfsmount *mnt;
-	struct mm_struct *mm = get_task_mm(tsk);
-	struct dentry *dentry;
-	char *lname;
-	int rc = 0;
-
-	*buf = '\0';
-	if (!mm) {
-		return -EINVAL;
-	}
-	down_read(&mm->mmap_sem);
-	vma = mm->mmap;
-	while (vma) {
-		if ((vma->vm_flags & VM_EXECUTABLE) && vma->vm_file) {
-			dentry = dget(vma->vm_file->f_dentry);
-			mnt = mntget(vma->vm_file->f_vfsmnt);
-			lname = d_path(dentry, mnt, buf, buflen);
-			if (!IS_ERR(lname)) {
-				strncpy(buf, lname, strlen(lname) + 1);
-			} else {
-				rc = (int)PTR_ERR(lname);
-			}
-			mntput(mnt);
-			dput(dentry);
-			break;
-		}
-		vma = vma->vm_next;
-	}
-	up_read(&mm->mmap_sem);
-	mmput(mm);
-	return rc;
-}
-
 /*
- * TODO:  Use sparce to enforce cnt_lock.
+ * TODO:  Use sparse to enforce cnt_lock.
  *
  * must be called with cnt_lock of parres held
  * Caller is responsible for making sure that the new guarantee doesn't
  * overflow parent's total guarantee.
  */
@@ -185,9 +149,8 @@ set_shares(struct ckrm_shares *new, stru
 	rc = 0;
 set_share_err:
 	return rc;
 }
 
-EXPORT_SYMBOL_GPL(get_exe_path_name);
 EXPORT_SYMBOL_GPL(child_guarantee_changed);
 EXPORT_SYMBOL_GPL(child_maxlimit_changed);
 EXPORT_SYMBOL_GPL(set_shares);
